#ifndef BORDER_DRAWING_H
#define BORDER_DRAWING_H

class BorderDrawing
{
private:
	sf::Texture grayTexture;
	sf::Sprite graySprite;
	sf::Texture redTexture;
	sf::Sprite redSprite;

public:
	explicit BorderDrawing(std::ofstream& errorLog);
	~BorderDrawing() = default;
	BorderDrawing( const BorderDrawing& Copy ) = delete;
	BorderDrawing& operator= ( const BorderDrawing& Copy ) = delete;
	
	void loadTextureAndSprite(std::ofstream& errorLog, const std::string& texturePath, sf::Texture& texture, sf::Sprite& sprite);
	
	void drawAllBorders(sf::RenderWindow& rendWindow);
	void drawWall(sf::RenderWindow& rendWindow, int wall_x_pos);
	//void drawLeftWall(sf::RenderWindow& rendWindow);
	//void drawRightWall(sf::RenderWindow& rendWindow);
	void drawBottomWall(sf::RenderWindow& rendWindow);
};

#endif //BORDER_DRAWING_H