#include <fstream>
#include <array>
#include "constexpr.h"
#include "SFML/Window.hpp"
#include "SFML/Graphics.hpp"
#include "playerScore.h"

PlayerScore::PlayerScore( std::ofstream& errorLog):
	canUpdateScore{false},
	score{0}
{
	if( arial.loadFromFile(ARIALFONTPATH) )
	{
		scoreTexture.setFont(arial);
		scoreTexture.setString("Score: " + std::to_string( score ) );
		scoreTexture.setCharacterSize(24);
		scoreTexture.setFillColor( sf::Color::White );
		scoreTexture.setPosition((BIGMAT_WIDTH + 4) * SQR_SIZE, 6 * SQR_SIZE );
	}
	else{
		errorLog << "Error: couldn't load the following font for the score: " << ARIALFONTPATH << " .\n";
	}
}

void PlayerScore::updateScoreText()
{
	if( canUpdateScore )
	{
		scoreTexture.setString( "Score: " + std::to_string( score ) );
		canUpdateScore = false;
	}
}

void PlayerScore::addToScore(long unsigned toAdd)
{
	score += toAdd;
	canUpdateScore = true;
}

void PlayerScore::drawScore(sf::RenderWindow& render) const
{
	render.draw(scoreTexture);
}

long unsigned PlayerScore::getScore() const
{
	return score;
}