#include <array>
#include "constexpr.h"
#include "tempMatrix.h"
#include "scanLinesInfos.h"
#include "randomSingleton.h"
#include "loadedPieces.h"
#include "activePieceThings.h"
#include "moveCurrentPieceToMatrix.h"

void moveCurrentPieceToMatrix(const ActivePiece& pieceData, const Piece& piece, MatrixTemp2D<SquareData>& matrix, ScanLinesInfos& scanLinesInf)
{
	for( int posx{0} ; posx < piece.width(pieceData.rotateIndex) ; ++posx )
	{
		for( int posy{0} ; posy < piece.height(pieceData.rotateIndex) ; ++posy )
		{
			if( piece.getPresenceSquare(pieceData.rotateIndex, posx, posy) )
			{
				if( matrix.isInsideBoundariesSigned(pieceData.posx + posx, pieceData.posy + posy) )
				{
					matrix(pieceData.posx + posx, pieceData.posy + posy).color = pieceData.colorIndex;
					matrix(pieceData.posx + posx, pieceData.posy + posy).filled = true;
				}
			}
		}
	}
	scanLinesInf.canScanToRemoveLines = true;
	scanLinesInf.topLine = pieceData.posy;
	scanLinesInf.bottomLine = pieceData.posy + piece.height(pieceData.rotateIndex) - 1;
}