#ifndef USER_INPUT_H
#define USER_INPUT_H

enum KEY{MV_PIECE_LEFT, MV_PIECE_RIGHT, DOWN_FASTER, ROT_PIECE_CWISE, ROT_PIECE_ANTICWISE, INP_MAX};

class UserInput
{
private:
	std::array<bool, KEY::INP_MAX> keysStates;
	bool escapeState;
	bool closeWindow;
	int mouse_pos_x,
		mouse_pos_y;
	bool leftMouseButton;
	sf::Event Event;
	
public:
	UserInput();
	~UserInput() = default;
	UserInput( const UserInput& Copy ) = delete;
	UserInput& operator= ( const UserInput& Copy ) = delete;
	
	void updateEvents(sf::RenderWindow& renderer);
	void updateKeyboard(sf::Keyboard::Key& key, bool valueToSet);
	bool getKeyState(size_t index) const;
	void setKeyState(size_t index, bool newValue);
	
	void mouseMoved();
	void mouseButton(bool valueToSet);
	int getMousePosX() const;
	int getMousePosY() const;
	bool getMouseLeftButton() const;
	void setMouseLeftButtonFalse();
	
	bool getWindowClose() const;
	void setWindowCloseFalse();
	bool getEscapeState() const;
	void setEscapeKeyFalse();
};

#endif //USER_INPUT_H