#ifndef ACTIVE_PIECE_THINGS_H
#define ACTIVE_PIECE_THINGS_H

struct ActivePiece
{
	size_t pieceIndex,
		   rotateIndex;
	int posx,
		posy;
	size_t colorIndex;
	
	ActivePiece(RandomSingleton& Rand, LoadedPieces& AllPieces):
		pieceIndex{Rand.getRandomNumber(0)}, 
		rotateIndex{ROT_IND::NORTH}, 
		posx{BIGMAT_WIDTH/2 - 1}, 
		posy{0}, 
		colorIndex{AllPieces.getPiece(pieceIndex).getColor()}
	{}
	
	void resetPieceValues(RandomSingleton& Rand, const LoadedPieces& Pieces)
	{
		pieceIndex = Rand.getRandomNumber(0);
		rotateIndex = ROT_IND::NORTH;
		posx = BIGMAT_WIDTH / 2 - 1;
		posy = 0;
		colorIndex = Pieces.getPiece(pieceIndex).getColor();
	}
};

#endif //ACTIVE_PIECE_THINGS_H