#ifndef GLOBAL_GAME_OBJECT_H
#define GLOBAL_GAME_OBJECT_H


#include "SFML/Window.hpp"
#include "SFML/Graphics.hpp"
#include "constexpr.h"
#include "tempMatrix.h"
#include "timeDelayClass.h"
#include "borderDrawing.h"
#include "squareTexturing.h"
#include "randomSingleton.h"
#include "loadedPieces.h"
#include "activePieceThings.h"
#include "scanLinesInfos.h"
#include "playerScore.h"

struct GameObject
{
	TimeDelay drawingFreq,
			  pieceFallTime;
	BorderDrawing borderDraw;
	SquaresDrawing sqrDraw;
	LoadedPieces allPieces;
	MatrixTemp2D<SquareData> matrix;
	RandomSingleton random;
	ActivePiece currentPiece;
	ScanLinesInfos scanLinesInf;
	PlayerScore playScore;
	
//Member functions	
	GameObject(std::ofstream& errorLog, unsigned skillLevel);
	Piece getCurrentPiece() const;
	Piece& getCurrentPiece();
	
	bool isSquarePresent(int x_sqr, int y_sqr) const;
	
	int getCurrentPieceWidth() const;
	int getCurrentPieceHeight() const;
	
	void moveCurrentPieceDowner();
	
	void movePieceToMatrix();
	void resetCurrentPiece();
	
	void drawEverything(sf::RenderWindow& renderer);
};

#endif //GLOBAL_GAME_OBJECT_H