#ifndef TIME_DELAY_CLASS_H
#define TIME_DELAY_CLASS_H

#include <chrono>

class TimeDelay
{
private:
	std::chrono::steady_clock::time_point current_, 
										  precedent_;
	std::chrono::duration<double, std::milli> delayDuration_;
	double delay;
	
public:
	TimeDelay(double delayDuration);
	~TimeDelay() = default;
	TimeDelay();
	
	bool delaySufficient(double customDelay);
	bool delaySufficient();
};

#endif //TIME_DELAY_CLASS_H