#ifndef SCORE_GRAPHICS_H
#define SCORE_GRAPHICS_H

#include "scoresInfos.h"

class ScoresGraphics
{
private:
	sf::Text title;
	std::array< SkillLevelScore, GAME_MAX > scoresData;

public:
	ScoresGraphics(std::ofstream& errorLog, const PrefPathFinder& prefPath, const sf::Font& arial);
	~ScoresGraphics() = default;
	ScoresGraphics& operator= ( const ScoresGraphics& ) = delete;
	ScoresGraphics ( const ScoresGraphics& ) = delete;
	
	void drawScores(sf::RenderWindow& renderer) const;
	void loadScoreFile(std::ofstream& errorLog, const std::string& scoreFilePath, unsigned skill);
	void createScoreTexts();
	void addCurrentScoreToBest(long unsigned newScore, unsigned skill);
	
	void sortScoresArray(std::array<ScoreInfo, SCORE_NUM_PER_SKILL>& scores);
	
	void outputScoresToFile(std::ofstream& errorLog, const PrefPathFinder& prefPath);
	void writeSingleFile(std::ofstream& errorLog, const PrefPathFinder& prefPath, const std::string& fileName, unsigned skill);
};

bool compareScores(const ScoreInfo& first, const ScoreInfo& second);

#endif //SCORE_GRAPHICS_H